(*
 *  This file is a component of PropPlan - a model-based planner
 *  Copyright (C) 2000-2007  Michael Paul Fourman
 *  homepages.inf.ed.ac.uk/mfourman/tools/propplan
 *  sourceforge.net/projects/propplan
 *  michael.fourman (AT) gmail.com
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of version 3 of the GNU Affero General Public License
 *  as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received the file COPYING, a copy of the GNU Affero 
 *  Public License, along with this program.  
 *  If not, see <http://www.gnu.org/licenses/>.
 
 *  $Id: PLANTYPES.ML,v 1.1 2007/12/30 15:31:25 michaelfourman Exp $
 *)

functor PLANTYPES(structure Bdd:LOGICSIG) = 
    struct
	open Bdd;

	datatype Action = 
	    Action of {
		       name       : string,
		       token      : Var,
		       precond    : Bdd,
		       changes    : Vars,
		       effect     : Bdd,
		       conditions : Vars,
		       condChanges:(Bdd * Vars) list
		       }  

	fun actionName (Action a) = #name a
	fun actionToken(Action a) = #token a

	datatype CompiledProblem = 
	    CompiledProblem of {
			name : string,
			init : Bdd,
			goals : (string * Bdd) list,
			constraint : Bdd,
			stateVars : Vars,
			acts : Action list 
			}

	    exception Abort
    end
